// RamStatus.cpp : Defines the entry point for the console application.
//

#pragma once

#include "targetver.h"
#include <windows.h>
#include <stdio.h>
#include <tchar.h>

// Use to convert bytes to KB
#define DIV 1024

// Specify the width of the field in which to print the numbers. 
// The asterisk in the format specifier "%*I64d" takes an integer 
// argument and uses it to pad and right justify the number.
#define WIDTH 7


int _tmain(int argc, _TCHAR* argv[])
{
  MEMORYSTATUSEX statex;

  statex.dwLength = sizeof (statex);

  GlobalMemoryStatusEx (&statex);

  printf ("Total RAM : %*I64d Kb\n",
          WIDTH, statex.ullTotalPhys/DIV);
  printf ("Free RAM : %*I64d Kb\n",
          WIDTH, statex.ullAvailPhys/DIV);
  printf ("Free  percent : %*ld\n",
          WIDTH, 100 - statex.dwMemoryLoad);
  printf ("Total Paging File : %*I64d Kb\n",
          WIDTH, statex.ullTotalPageFile/DIV);
  printf ("Free Paging File : %*I64d Kb\n",
          WIDTH, statex.ullAvailPageFile/DIV);
  printf ("Total Virtual Memory : %*I64d Kb\n",
          WIDTH, statex.ullTotalVirtual/DIV);
  printf ("Free Virtual Memory : %*I64d Kb\n",
          WIDTH, statex.ullAvailVirtual/DIV);
  printf ("Free Extended Memory : %*I64d Kb\n",
          WIDTH, statex.ullAvailExtendedVirtual/DIV);

  return 0;
}

