// hiderunEx.cpp : Defines the entry point for the console application.
//

#pragma once

#include "targetver.h"

#include <stdio.h>
#include <tchar.h>
#include <windows.h>
#include <shellapi.h>

#define PARMLEN 4096

bool StartWait(LPCWSTR exeFile, LPCWSTR startParams, LPCWSTR workDir, bool wait, bool show)
{
//function StartWait(const exeFile, startParams, workDir: string; wait, show: boolean): boolean;
  SHELLEXECUTEINFO   SEInfo;
  DWORD   exitCode;
 
  int infsize = sizeof(SHELLEXECUTEINFO);
  memset(&SEInfo, 0, infsize);
  SEInfo.cbSize =  infsize;
  SEInfo.fMask =  SEE_MASK_NOCLOSEPROCESS;
  SEInfo.lpFile =  exeFile;
  SEInfo.lpParameters =  startParams;
  SEInfo.lpDirectory =  workDir;
  if(show)
    SEInfo.nShow =  SW_SHOWNORMAL;
  else
    SEInfo.nShow =  SW_HIDE;
  if(ShellExecuteEx(&SEInfo))
  { 
   if(wait)
     do{
       MsgWaitForMultipleObjects(1, &SEInfo.hProcess, FALSE, 10, QS_ALLINPUT);
       GetExitCodeProcess(SEInfo.hProcess, &exitCode);
     }while((exitCode == STILL_ACTIVE));
   return TRUE;
  } 
  else
	return false;
}

void sting2wide(char *src, char *trg)
{
	char *s = src;
	char *t = trg;
  for(;;)
  {
	  *t++ = *s;
	  *t++ = 0;
	  if (*s++ == 0)
	  {
		  *t++ = 0;
		  *t++ = 0;
		  break;
	  }
  }
}

int main(int argc,
    char *argv[ ],
    char **envp)
{
  bool wait = false;
  int start = 1;
  char *exe;
  char *parms;
  char *wparms;
  char *wexe;
  bool quote;

  if (argc == 1) 
	  return -1;
  if (_stricmp("/w", argv[1]) == 0)
  {  start++;
	 wait = true;
  }

  parms = (char*) malloc (PARMLEN);
  exe = argv[start++];
  parms[0] = 0;
  for(;start < argc;start++)
  {
	  quote = (strstr(argv[start], " ") != NULL);
	  if (quote)
		  strcat_s(&parms[0], PARMLEN, "\"");
	  strcat_s(&parms[0], PARMLEN, argv[start]);
	  if (quote)
		  strcat_s(&parms[0], PARMLEN, "\"");
	  strcat_s(&parms[0], PARMLEN, " ");
  }
  wexe = (char*) malloc (2 * strlen(exe) + 4);
  sting2wide(exe, &wexe[0]);
  wparms = (char*) malloc (2 * strlen(parms) + 4);
  sting2wide(parms, wparms);
  StartWait((LPCWSTR)wexe, (LPCWSTR)wparms, NULL, wait, false);
  free(parms);
  free(wexe);
  free(wparms);
return 0;
}
