// resShort.cpp : Defines the entry point for the console application.
//

#pragma once
#pragma comment(lib, "uuid.lib")

#include "targetver.h"

#include <stdio.h>
#include <tchar.h>
#include <string.h>
#include <windows.h>
#include <ShlObj.h>
#include <stdlib.h>
#include <malloc.h>


HRESULT ResolveIt(LPCWSTR lpszLinkFile) 
{ 
    HRESULT hres; 
    IShellLink* psl; 
    CoInitialize(NULL);

    hres = CoCreateInstance(CLSID_ShellLink, NULL, CLSCTX_INPROC_SERVER, 
                            IID_IShellLink, (LPVOID*)&psl); 
    if (SUCCEEDED(hres)) 
    { 
        IPersistFile* ppf; 
 
        hres = psl->QueryInterface(IID_IPersistFile, (void**)&ppf); 
		
        if (SUCCEEDED(hres)) 
        { 

            hres = ppf->Load(lpszLinkFile, STGM_READWRITE); 
            
            if (SUCCEEDED(hres)) 
            { 
                hres = psl->Resolve(NULL, SLR_NO_UI | SLR_UPDATE); 
	            if (SUCCEEDED(hres))
					hres = ppf->Save(lpszLinkFile, false);

            } 

            ppf->Release(); 
        } 

        psl->Release(); 
    }
	CoUninitialize();
    return hres; 
}
void dowork(wchar_t *path)
{
	HANDLE fnd;
	WIN32_FIND_DATA info;
	wchar_t *wpth;
	size_t siz;
    if (*path != '.')
	{
		siz = 2 * (wcslen(path) + 10);
		wpth = (wchar_t *)malloc(siz);
#pragma warning(disable:4996)
		wcscpy(wpth, path);
	    wcscat(wpth, L"\\*"); 
#pragma warning(default:4996)
		fnd = FindFirstFile(wpth, &info);
		free(wpth);
		while (fnd != INVALID_HANDLE_VALUE)
		{ 
			if (*info.cFileName != '.')
			{
				siz = 2 * (wcslen(path) + wcslen(info.cFileName) + 2);
				wpth = (wchar_t *)malloc(siz);
#pragma warning(disable:4996)
				wcscpy(wpth, path);
			    wcscat(wpth, L"\\"); 
			    wcscat(wpth, info.cFileName); 
#pragma warning(default:4996)
				if ((info.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY) == FILE_ATTRIBUTE_DIRECTORY)
				{
					dowork(wpth);
				}
				else
				{
					if (wcsstr(info.cFileName, L".lnk") != NULL)
					{
						printf("Resolving shortcut %S\n", info.cFileName); 
						ResolveIt(wpth);
					}
				}
				free(wpth);
			}
			if (!FindNextFile(fnd, &info))
				break;
		}
		FindClose(fnd);
	}
}


int main(int argc, char *argv[ ], char **envp)
{
  char * pch;
  char *basedir;
  wchar_t *wpth;
  size_t siz;
  if (argc == 1)
  { 
	  siz = strlen(argv[0]) + 1;
      basedir = (char*) malloc (siz);
	  strcpy_s(basedir, siz, argv[0]);
	  pch = strrchr(basedir, '\\');
	  *pch = 0;
  }
  else
  {
	  siz = strlen(argv[1]) + 1;
      basedir = (char*) malloc (siz);
	  strcpy_s(basedir, siz, argv[1]);
  }
  siz = 2 * (strlen(basedir) + 1);
  wpth = (wchar_t *) malloc(siz);
#pragma warning(disable:4996)
  siz = mbstowcs(wpth, basedir, siz);
#pragma warning(default:4996)
  *(wpth + siz) = 0;
  dowork(wpth);
  free(basedir);
  free(wpth);
  return 0;
}

